<?php

namespace Teknisa\SM\Service;
use Teknisa\Libs\Util\Environment;
use Teknisa\SM\Factory\Sm00015004RecursoTarefaFactory;

class Sm00015004RecursoTarefaService
{
    protected $recursoTarefaFactory;
    protected $Environment;
    
    public function __construct (Sm00015004RecursoTarefaFactory $recursoTarefaFactory, Environment $Environment) {
        $this->recursoTarefaFactory = $recursoTarefaFactory;
        $this->Environment  = $Environment;
    }
    
    /**
     *  A função "recebeOrdenacao" recebe a próxima a ordenação da tarefa 
     *  que está sendo inserida para a recurso.
     */
    
    public function recebeOrdenacao($nrRecursosAgendCont){
    
        $params = array(
            "NRRECURSOSAGENDCONT" => $nrRecursosAgendCont,
            "NRORG"         => $this->Environment->getNrOrg()
        );
        
        $ordenacao = $this->recursoTarefaFactory->recebeOrdenacao($params);
        
        return $ordenacao[0];
    }
    
    /**
     *  A função "validar" verifica se já existe a ordenação da tarefa 
     *  que está sendo inserida para a recurso.
     */
     
    public function validar($ordenacao, $nrRecursosAgendCont, $nrorg) {
        
        $params = array(
            "NRRECURSOSAGENDCONT" => $nrRecursosAgendCont,
            "IDORDENACAO"         => $ordenacao,
            "NRORG"               => $this->Environment->getNrOrg()
        );
        
        $dados = $this->recursoTarefaFactory-> validar($params); 
        $resultado = $dados[0]["EXISTE"];
        return ($resultado == 0);
    }
}

?>