/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_GRUPOPER                                                 */
/* Tabela : GRUPOPER                                                          */
/*                                                                            */
/* Criao:                                                                   */
/* 04/05/2004 - David Moreno Ferreira                                         */
/*                                                                            */
/******************************************************************************/

IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'DTULTATU_GRUPOPER' and
            type = 'TR'               and
            u.uid = o.uid             and
            u.name = USER)
   DROP TRIGGER DTULTATU_GRUPOPER
GO

CREATE TRIGGER DTULTATU_GRUPOPER
ON GRUPOPER
FOR INSERT, UPDATE, DELETE
AS
BEGIN
   IF (0 = (SELECT COUNT(*) FROM INSERTED)) BEGIN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
			      (SELECT 'GRUPOPER', null, 'CDGRUPOPER=' + CDGRUPOPER + ';', CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) FROM DELETED)
   END
   ELSE BEGIN
      UPDATE GRUPOPER
      SET DTULTATUGROP = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
      FROM INSERTED
      WHERE (ISNULL(GRUPOPER.CDGRUPOPER,0)   = ISNULL(INSERTED.CDGRUPOPER,0  )) AND
            (ISNULL(GRUPOPER.DSGRUPOPER,0)   = ISNULL(INSERTED.DSGRUPOPER,0  )) AND
            (ISNULL(GRUPOPER.IDUTCTRSENOP,0) = ISNULL(INSERTED.IDUTCTRSENOP,0)) AND
            (ISNULL(GRUPOPER.DSSENHACAIXA,0) = ISNULL(INSERTED.DSSENHACAIXA,0)) AND
	    (ISNULL(GRUPOPER.IDALTERCORES,0) = ISNULL(INSERTED.IDALTERCORES,0)) AND
            (ISNULL(GRUPOPER.IDALTERIDIOMAS,0) = ISNULL(INSERTED.IDALTERIDIOMAS,0)) AND
            (ISNULL(GRUPOPER.IDALTERCONFIG,0) = ISNULL(INSERTED.IDALTERCONFIG,0)) AND
            (ISNULL(GRUPOPER.IDEMITIRFECHA,0) = ISNULL(INSERTED.IDEMITIRFECHA,0)) AND
            (ISNULL(GRUPOPER.IDCANCELARVENDAS,0) = ISNULL(INSERTED.IDCANCELARVENDAS,0)) AND
            (ISNULL(GRUPOPER.IDBLOCKPROD,0) = ISNULL(INSERTED.IDBLOCKPROD,0)) AND
            (ISNULL(GRUPOPER.IDALTERMODAL,0) = ISNULL(INSERTED.IDALTERMODAL,0)) AND
            (ISNULL(GRUPOPER.IDALTERIMP,0) = ISNULL(INSERTED.IDALTERIMP,0)) AND
            (ISNULL(GRUPOPER.IDALTERLAYOUT,0) = ISNULL(INSERTED.IDALTERLAYOUT,0)) AND
            (ISNULL(GRUPOPER.IDALTERCONFIGGERAIS,0) = ISNULL(INSERTED.IDALTERCONFIGGERAIS,0)) AND
            (ISNULL(GRUPOPER.IDALTERIMAGENS,0) = ISNULL(INSERTED.IDALTERIMAGENS,0)) AND
            (ISNULL(GRUPOPER.IDIMPORTARCONFIG,0) = ISNULL(INSERTED.IDIMPORTARCONFIG,0)) AND
            (ISNULL(GRUPOPER.IDEXPORTARCONFIG,0) = ISNULL(INSERTED.IDEXPORTARCONFIG,0)) AND
            (ISNULL(GRUPOPER.IDPARAMETROS,0) = ISNULL(INSERTED.IDPARAMETROS,0)) AND
            (ISNULL(GRUPOPER.IDGESTAOSISTEM,0) = ISNULL(INSERTED.IDGESTAOSISTEM,0)) AND
            (ISNULL(GRUPOPER.IDCONFIGVERSAO,0) = ISNULL(INSERTED.IDCONFIGVERSAO,0)) AND
            (ISNULL(GRUPOPER.IDGERENSERVI,0) = ISNULL(INSERTED.IDGERENSERVI,0));
   END;
END;
GO

UPDATE GRUPOPER SET DTULTATUGROP = CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108)) WHERE DTULTATUGROP IS NULL
GO

IF EXISTS(SELECT * FROM sysobjects O
          WHERE
            o.name = 'DEFAULT_DTULTATUGROP' and
            type = 'D')
   ALTER TABLE GRUPOPER DROP CONSTRAINT DEFAULT_DTULTATUGROP
GO

ALTER TABLE GRUPOPER ADD CONSTRAINT DEFAULT_DTULTATUGROP
DEFAULT CONVERT(DATETIME,CONVERT(VARCHAR,GETDATE(),103)+' '+CONVERT(VARCHAR,GETDATE(),108))
FOR DTULTATUGROP
GO

-- VERSAO --
EXEC ATUVEROBJ 'DTULTATU_GRUPOPER','6.49.040';
GO

