/* Tabela ITEMPEDIDO: Item do Pedido */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela ITEMPEDIDO */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela Item do Pedido,
             utilizando a tabela Geral de Logs de Operaes */
IF EXISTS(SELECT * FROM sysobjects O, sysusers U
          WHERE
            o.name = 'LOG_PED_ITEMPEDIDO' and
            type = 'TR'                   and
            u.uid = o.uid                 and
            u.name = USER)
  DROP TRIGGER LOG_PED_ITEMPEDIDO
  GO

CREATE TRIGGER LOG_PED_ITEMPEDIDO
ON ITEMPEDIDO
FOR INSERT, UPDATE, DELETE
AS
   DECLARE @V_USUARIO         VARCHAR(40);
   DECLARE @V_TIPO            VARCHAR(1);
   DECLARE @V_ITPESQ          VARCHAR(40);
   DECLARE @V_DESC            VARCHAR(300);
   DECLARE @V_CDFILLOGOPER    VARCHAR(4);
   DECLARE @V_DTOPER          DATETIME;
   DECLARE @V_STSITPED        VARCHAR(2);
   DECLARE @V_CDARVPROD       VARCHAR(20);

/*VARIVEIS DO CURSOR C_CURSOR*/
   DECLARE @V_ID_COMANDO       VARCHAR(1);

   DECLARE @V_CDFILIAL_OLD     VARCHAR(4);
   DECLARE @V_NRPEDIDO_OLD     VARCHAR(10);
   DECLARE @V_NRITEMPED_OLD    VARCHAR(10);
   DECLARE @V_IDSITITEMPED_OLD VARCHAR(1);
   DECLARE @V_CDPRODUTO_OLD    VARCHAR(10);
   DECLARE @V_QTITEMPED_OLD    double precision;
   DECLARE @V_VRPREUNITPED_OLD double precision;
   DECLARE @V_CDFATPRECO_OLD   VARCHAR(3);
   DECLARE @V_VRFATPRECOIT_OLD double precision;
   DECLARE @V_VRDESITPED_OLD   double precision;
   DECLARE @V_DTENTITPED_OLD   DATETIME;
   DECLARE @V_IDITPEDDIFER_OLD VARCHAR(1);
   DECLARE @V_VRPRELIQITPED_OLD double precision;

   DECLARE @V_CDFILIAL_NEW     VARCHAR(4);
   DECLARE @V_NRPEDIDO_NEW     VARCHAR(10);
   DECLARE @V_NRITEMPED_NEW    VARCHAR(10);
   DECLARE @V_IDSITITEMPED_NEW VARCHAR(1);
   DECLARE @V_CDPRODUTO_NEW    VARCHAR(10);
   DECLARE @V_QTITEMPED_NEW    double precision;
   DECLARE @V_VRPREUNITPED_NEW double precision;
   DECLARE @V_CDFATPRECO_NEW   VARCHAR(3);
   DECLARE @V_VRFATPRECOIT_NEW double precision;
   DECLARE @V_VRDESITPED_NEW   double precision;
   DECLARE @V_DTENTITPED_NEW   DATETIME;
   DECLARE @V_IDITPEDDIFER_NEW VARCHAR(1);
   DECLARE @V_VRPRELIQITPED_NEW double precision;
BEGIN

   SET @V_DESC     = '';
   SET @V_STSITPED = '';
   SET @V_TIPO     = '0';
   SET @V_CDFILLOGOPER = '';

   EXEC NMUSUARIO @V_USUARIO;
   SET @V_USUARIO = ISNULL(@V_USUARIO, '');

   DECLARE C_CURSOR CURSOR FOR
      SELECT
         'D' IDCOMANDO,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,

         CDFILIAL,
         NRPEDIDO,
         NRITEMPED,
         IDSITITEMPED,
         CDPRODUTO,
         QTITEMPED,
         VRPREUNITPED,
         CDFATPRECO,
         VRFATPRECOIT,
         VRDESITPED,
         DTENTITPED,
         IDITPEDDIFER
      FROM
         DELETED
      WHERE
         0 = (SELECT COUNT(*) FROM INSERTED)

      UNION ALL

      SELECT
         'U' IDCOMANDO,

         INSERTED.CDFILIAL,
         INSERTED.NRPEDIDO,
         INSERTED.NRITEMPED,
         INSERTED.IDSITITEMPED,
         INSERTED.CDPRODUTO,
         INSERTED.QTITEMPED,
         INSERTED.VRPREUNITPED,
         INSERTED.CDFATPRECO,
         INSERTED.VRFATPRECOIT,
         INSERTED.VRDESITPED,
         INSERTED.DTENTITPED,
         INSERTED.IDITPEDDIFER,

         DELETED.CDFILIAL,
         DELETED.NRPEDIDO,
         DELETED.NRITEMPED,
         DELETED.IDSITITEMPED,
         DELETED.CDPRODUTO,
         DELETED.QTITEMPED,
         DELETED.VRPREUNITPED,
         DELETED.CDFATPRECO,
         DELETED.VRFATPRECOIT,
         DELETED.VRDESITPED,
         DELETED.DTENTITPED,
         DELETED.IDITPEDDIFER
      FROM
         INSERTED,
         DELETED
      WHERE
         INSERTED.CDFILIAL  = DELETED.CDFILIAL AND
         INSERTED.NRPEDIDO  = DELETED.NRPEDIDO AND
         INSERTED.NRITEMPED = DELETED.NRITEMPED

      UNION ALL

      SELECT
         'I' IDCOMANDO,

         INSERTED.CDFILIAL,
         INSERTED.NRPEDIDO,
         INSERTED.NRITEMPED,
         INSERTED.IDSITITEMPED,
         INSERTED.CDPRODUTO,
         INSERTED.QTITEMPED,
         INSERTED.VRPREUNITPED,
         INSERTED.CDFATPRECO,
         INSERTED.VRFATPRECOIT,
         INSERTED.VRDESITPED,
         INSERTED.DTENTITPED,
         INSERTED.IDITPEDDIFER,

         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL,
         NULL
      FROM
         INSERTED
      WHERE
         0 = (SELECT COUNT(*) FROM DELETED)

   OPEN C_CURSOR;
   FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,

                                 @V_CDFILIAL_OLD,
                                 @V_NRPEDIDO_OLD,
                                 @V_NRITEMPED_OLD,
                                 @V_IDSITITEMPED_OLD,
                                 @V_CDPRODUTO_OLD,
                                 @V_QTITEMPED_OLD,
                                 @V_VRPREUNITPED_OLD,
                                 @V_VRPRELIQITPED_OLD,
                                 @V_CDFATPRECO_OLD,
                                 @V_VRFATPRECOIT_OLD,
                                 @V_VRDESITPED_OLD,
                                 @V_DTENTITPED_OLD,
                                 @V_IDITPEDDIFER_OLD,

                                 @V_CDFILIAL_NEW,
                                 @V_NRPEDIDO_NEW,
                                 @V_NRITEMPED_NEW,
                                 @V_IDSITITEMPED_NEW,
                                 @V_CDPRODUTO_NEW,
                                 @V_QTITEMPED_NEW,
                                 @V_VRPREUNITPED_NEW,
                                 @V_VRPRELIQITPED_NEW,
                                 @V_CDFATPRECO_NEW,
                                 @V_VRFATPRECOIT_NEW,
                                 @V_VRDESITPED_NEW,
                                 @V_DTENTITPED_NEW,
                                 @V_IDITPEDDIFER_NEW ;

   WHILE (@@FETCH_STATUS = 0) BEGIN
      IF NOT @V_USUARIO IS NULL BEGIN
         IF @V_ID_COMANDO = 'D'  BEGIN
            SET @V_TIPO = '3';

            SELECT @V_CDARVPROD = CDARVPROD
            FROM PRODUTO
            WHERE CDPRODUTO = ISNULL(@V_CDPRODUTO_NEW, @V_CDPRODUTO_OLD);

            SET @V_DESC   = 'Filial '    + ISNULL(@V_CDFILIAL_NEW, @V_CDFILIAL_OLD  ) + ' ' +
                            'Pedido '    + ISNULL(@V_NRPEDIDO_NEW, @V_NRPEDIDO_OLD  ) + ' ' +
                            'Item '      + ISNULL(@V_NRITEMPED_NEW, @V_NRITEMPED_OLD) + ' ' +
                            'Produto '   + @V_CDARVPROD     + ' ' +
                            'Qtde. Ped ' + CONVERT(CHAR,(ROUND(ISNULL(@V_QTITEMPED_NEW, @V_QTITEMPED_OLD), 3)));

            IF @V_VRPREUNITPED_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Preo Unit. ' + CONVERT(CHAR,(ROUND(@V_VRPREUNITPED_OLD, 2)));
            END;
            IF @V_VRPRELIQITPED_OLD IS NOT NULL BEGIN
               SET @V_DES = @V_DESC + ' Preo Liq. ' + CONVERT(CHAR,(ROUND(@V_VRPRELIQITPED_OLD, 2)));
            END;
            IF @V_CDFATPRECO_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' SG. Fator ' + @V_CDFATPRECO_OLD;
            END;
            IF @V_VRFATPRECOIT_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Fator ' + CONVERT(CHAR,(ROUND(@V_VRFATPRECOIT_OLD, 2)));
            END;
            IF @V_IDSITITEMPED_OLD = '1' BEGIN SET @V_STSITPED = 'PE'; END;
            IF @V_IDSITITEMPED_OLD = '2' BEGIN SET @V_STSITPED = 'CF'; END;
            IF @V_IDSITITEMPED_OLD = '3' BEGIN SET @V_STSITPED = 'AP'; END;
            IF @V_IDSITITEMPED_OLD = '4' BEGIN SET @V_STSITPED = 'LQ'; END;
            IF @V_IDSITITEMPED_OLD = '5' BEGIN SET @V_STSITPED = 'CN'; END;
            IF @V_IDSITITEMPED_OLD = '6' BEGIN SET @V_STSITPED = 'LQ'; END;
            IF @V_IDSITITEMPED_OLD = '7' BEGIN SET @V_STSITPED = 'PA'; END;

            IF (@V_STSITPED <> '') BEGIN
               SET @V_DESC = @V_DESC + ' Situao ' + @V_STSITPED;
            END;
            IF @V_VRDESITPED_OLD IS NOT NULL BEGIN
               SET @V_DESC = @V_DESC + ' Vr. Desc. ' + CONVERT(CHAR, (ROUND(@V_VRDESITPED_OLD, 2)));
            END;

            SET @V_ITPESQ  = ISNULL(@V_CDFILIAL_NEW, @V_CDFILIAL_OLD)+ISNULL(@V_NRPEDIDO_NEW, @V_NRPEDIDO_OLD)+ISNULL(@V_NRITEMPED_NEW, @V_NRITEMPED_OLD);
            SET @V_CDFILLOGOPER = ISNULL(@V_CDFILIAL_NEW, @V_CDFILIAL_OLD);
         END
         ELSE BEGIN
            IF @V_ID_COMANDO = 'U' BEGIN
               SET @V_DESC   = 'Filial '    + @V_CDFILIAL_OLD  + ' ' +
                               'Pedido '    + @V_NRPEDIDO_OLD  + ' ' +
                               'Item '      + @V_NRITEMPED_OLD;
               IF (@V_QTITEMPED_OLD     <> @V_QTITEMPED_NEW) BEGIN
                  SET @V_DESC = @V_DESC + ' Alterado:';
                  SET @V_TIPO = '2';
               END;

               IF (@V_CDPRODUTO_OLD <> @V_CDPRODUTO_NEW) BEGIN
                  SELECT @V_CDARVPROD = CDARVPROD
                  FROM PRODUTO
                  WHERE CDPRODUTO = @V_CDPRODUTO_OLD;

                  SET @V_DESC = @V_DESC + ' Produto ' + @V_CDARVPROD;
               END;
               IF (@V_QTITEMPED_OLD <> @V_QTITEMPED_NEW) BEGIN
                  SET @V_DESC = @V_DESC + ' Qtde. Ped ' + CONVERT(VARCHAR,@V_QTITEMPED_OLD);
               END;
               IF (@V_VRPREUNITPED_OLD IS NULL) AND
                  (@V_VRPREUNITPED_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Preo Unit. NULL';
               END
               ELSE BEGIN
                  IF (@V_VRPREUNITPED_OLD <> @V_VRPREUNITPED_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' Preo Unit. ' + CONVERT(VARCHAR,@V_VRPREUNITPED_OLD);
                  END;
               END;
               IF (@V_VRPRELIQITPED_OLD IS NULL) AND
                  (@V_VRPRELIQITPED_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Preo Liq. NULL';
               END
               ELSE BEGIN
                  IF (@V_VRPRELIQITPED_OLD <> @V_VRPRELIQITPED_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' Preo Liq. ' + CONVERT(VARCHAR,@V_VRPRELIQITPED_OLD);
                  END;
               END;
               IF (@V_CDFATPRECO_OLD IS NULL) AND
                  (@V_CDFATPRECO_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' SG. Fator NULL';
               END
               ELSE BEGIN
                  IF (@V_CDFATPRECO_OLD <> @V_CDFATPRECO_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' SG. Fator ' + @V_CDFATPRECO_OLD;
                  END;
               END;
               IF (@V_VRFATPRECOIT_OLD IS NULL)     AND
                  (@V_VRFATPRECOIT_NEW IS NOT NULL) AND
                  (@V_VRPREUNITPED_NEW IS NULL)     BEGIN
                  SET @V_DESC = @V_DESC + ' Fator NULL';
               END
               ELSE BEGIN
                  IF (@V_VRFATPRECOIT_OLD <> @V_VRFATPRECOIT_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' Fator ' + CONVERT(VARCHAR, @V_VRFATPRECOIT_OLD);
                  END;
               END;
               IF (@V_IDSITITEMPED_OLD <> @V_IDSITITEMPED_NEW) BEGIN
                  IF @V_IDSITITEMPED_OLD = '1' BEGIN SET @V_STSITPED = 'PE'; END;
                  IF @V_IDSITITEMPED_OLD = '2' BEGIN SET @V_STSITPED = 'CF'; END;
                  IF @V_IDSITITEMPED_OLD = '3' BEGIN SET @V_STSITPED = 'AP'; END;
                  IF @V_IDSITITEMPED_OLD = '4' BEGIN SET @V_STSITPED = 'LQ'; END;
                  IF @V_IDSITITEMPED_OLD = '5' BEGIN SET @V_STSITPED = 'CN'; END;
                  IF @V_IDSITITEMPED_OLD = '6' BEGIN SET @V_STSITPED = 'LQ'; END;
                  IF @V_IDSITITEMPED_OLD = '7' BEGIN SET @V_STSITPED = 'PA'; END;

                  IF (@V_STSITPED <> '') BEGIN
                     SET @V_DESC = @V_DESC + ' Situao ' + @V_STSITPED;
                  END;
               END;
               IF (@V_VRDESITPED_OLD IS NULL) AND
                  (@V_VRDESITPED_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Vr. Desc. 0,00';
               END
               ELSE BEGIN
                  IF (@V_VRDESITPED_OLD <> @V_VRDESITPED_NEW) BEGIN
                     SET @V_DESC = @V_DESC + ' Vr. Desc. ' + CONVERT(VARCHAR, @V_VRDESITPED_OLD);
                  END;
               END;
               IF (@V_DTENTITPED_OLD <> @V_DTENTITPED_NEW) BEGIN
                  SET @V_DESC = @V_DESC + ' Dt. Entrega ' + CONVERT(CHAR, @V_DTENTITPED_OLD, 103);
               END;
               IF (@V_IDITPEDDIFER_OLD IS NULL) AND
                  (@V_IDITPEDDIFER_NEW IS NOT NULL) BEGIN
                  SET @V_DESC = @V_DESC + ' Tipo Normal';
               END
               ELSE BEGIN
                  IF (@V_IDITPEDDIFER_OLD <> @V_IDITPEDDIFER_NEW) BEGIN
                     IF @V_IDITPEDDIFER_OLD = 'S' BEGIN
                        SET @V_DESC = @V_DESC + ' Tipo Personalizado';
                     END
                     ELSE BEGIN
                        SET @V_DESC = @V_DESC + ' Tipo Normal';
                     END;
                  END;
               END;
               SET @V_ITPESQ  = @V_CDFILIAL_OLD+@V_NRPEDIDO_OLD+@V_NRITEMPED_OLD;
               SET @V_CDFILLOGOPER = @V_CDFILIAL_OLD;
            END
            ELSE BEGIN
               SET @V_TIPO = '1';

               SELECT @V_CDARVPROD = CDARVPROD
               FROM PRODUTO
               WHERE CDPRODUTO = ISNULL(@V_CDPRODUTO_NEW, @V_CDPRODUTO_OLD);

               SET @V_DESC   = 'Filial '    + ISNULL(@V_CDFILIAL_NEW, @V_CDFILIAL_OLD  ) + ' ' +
                               'Pedido '    + ISNULL(@V_NRPEDIDO_NEW, @V_NRPEDIDO_OLD  ) + ' ' +
                               'Item '      + ISNULL(@V_NRITEMPED_NEW, @V_NRITEMPED_OLD) + ' ' +
                               'Produto '   + @V_CDARVPROD     + ' ' +
                               'Qtde. Ped ' + CONVERT(CHAR,(ROUND(ISNULL(@V_QTITEMPED_NEW, @V_QTITEMPED_OLD), 3)));

               IF @V_VRPREUNITPED_NEW IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Preo Unit. ' + CONVERT(CHAR,(ROUND(@V_VRPREUNITPED_NEW, 2)));
               END;
               IF @V_VRPRELIQITPED_NEW IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Preo Liq. ' + CONVERT(CHAR,(ROUND(@V_VRPRELIQITPED_NEW, 2)));
               END;
               IF @V_CDFATPRECO_NEW IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + ' SG. Fator ' + @V_CDFATPRECO_NEW;
               END;
               IF @V_VRFATPRECOIT_NEW IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Fator ' + CONVERT(CHAR,(ROUND(@V_VRFATPRECOIT_NEW, 2)));
               END;
               IF @V_IDSITITEMPED_NEW = '1' BEGIN SET @V_STSITPED = 'PE'; END;
               IF @V_IDSITITEMPED_NEW = '2' BEGIN SET @V_STSITPED = 'CF'; END;
               IF @V_IDSITITEMPED_NEW = '3' BEGIN SET @V_STSITPED = 'AP'; END;
               IF @V_IDSITITEMPED_NEW = '4' BEGIN SET @V_STSITPED = 'LQ'; END;
               IF @V_IDSITITEMPED_NEW = '5' BEGIN SET @V_STSITPED = 'CN'; END;
               IF @V_IDSITITEMPED_NEW = '6' BEGIN SET @V_STSITPED = 'LQ'; END;
               IF @V_IDSITITEMPED_NEW = '7' BEGIN SET @V_STSITPED = 'PA'; END;

               IF (@V_STSITPED <> '') BEGIN
                  SET @V_DESC = @V_DESC + ' Situao ' + @V_STSITPED;
               END;
               IF @V_VRDESITPED_NEW IS NOT NULL BEGIN
                  SET @V_DESC = @V_DESC + ' Vr. Desc. ' + @V_VRDESITPED_NEW;
               END;

               SET @V_ITPESQ  = ISNULL(@V_CDFILIAL_NEW, @V_CDFILIAL_OLD)+ISNULL(@V_NRPEDIDO_NEW, @V_NRPEDIDO_OLD)+ISNULL(@V_NRITEMPED_NEW, @V_NRITEMPED_OLD);
               SET @V_CDFILLOGOPER = ISNULL(@V_CDFILIAL_NEW, @V_CDFILIAL_OLD);
            END;
         END;

         IF @V_TIPO <> '0' BEGIN
            SET @V_DESC = SUBSTRING(ISNULL(@V_DESC, ' '), 1, 300);
            SET @V_DTOPER = GETDATE();
            INSERT INTO LOGOPERA(NMTABELA, DTOPERACAO, NMRESPOPER,
                             IDTIPOOPER,   DSOPERACAO,  CDPESQITEM)
                  VALUES   ('ITEMPEDIDO', GETDATE() , @V_USUARIO,
                            @V_TIPO,   @V_DESC, @V_ITPESQ);
         END;
      END;

      FETCH NEXT FROM C_CURSOR INTO @V_ID_COMANDO,

                                    @V_CDFILIAL_OLD,
                                    @V_NRPEDIDO_OLD,
                                    @V_NRITEMPED_OLD,
                                    @V_IDSITITEMPED_OLD,
                                    @V_CDPRODUTO_OLD,
                                    @V_QTITEMPED_OLD,
                                    @V_VRPREUNITPED_OLD,
                                    @V_VRPRELIQITPED_OLD,
                                    @V_CDFATPRECO_OLD,
                                    @V_VRFATPRECOIT_OLD,
                                    @V_VRDESITPED_OLD,
                                    @V_DTENTITPED_OLD,
                                    @V_IDITPEDDIFER_OLD,

                                    @V_CDFILIAL_NEW,
                                    @V_NRPEDIDO_NEW,
                                    @V_NRITEMPED_NEW,
                                    @V_IDSITITEMPED_NEW,
                                    @V_CDPRODUTO_NEW,
                                    @V_QTITEMPED_NEW,
                                    @V_VRPREUNITPED_NEW,
                                    @V_VRPRELIQITPED_NEW,
                                    @V_CDFATPRECO_NEW,
                                    @V_VRFATPRECOIT_NEW,
                                    @V_VRDESITPED_NEW,
                                    @V_DTENTITPED_NEW,
                                    @V_IDITPEDDIFER_NEW ;

   END;
   CLOSE      C_CURSOR;
   DEALLOCATE C_CURSOR;
END;
GO
